diff --git a/yumcommands.py b/yumcommands.py
index 4dcbea7..b610f3a 100644
--- a/yumcommands.py
+++ b/yumcommands.py
@@ -389,65 +728,212 @@ class InfoCommand(YumCommand):
             return 0, []
 
     def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before this
+        command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
         if len(extcmds) and extcmds[0] == 'installed':
             return False
         
         return True
 
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        if len(extcmds) and extcmds[0] in ('updates', 'obsoletes'):
+            return 'read-only:future'
+        if len(extcmds) and extcmds[0] in ('installed', 'distro-extras', 'extras', 'recent'):
+            return 'read-only:past'
+        # available/all
+        return 'read-only:present'
+
+
 class ListCommand(InfoCommand):
+    """A class containing methods needed by the cli to execute the
+    list command.
+    """
+
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['list']
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("List a package or groups of packages")
 
 
 class EraseCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    erase command.
+    """
+
         
     def getNames(self):
-        return ['erase', 'remove']
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
+        return ['erase', 'remove',
+                'erase-n', 'erase-na', 'erase-nevra',
+                'remove-n', 'remove-na', 'remove-nevra']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return "PACKAGE..."
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Remove a package or packages from your system")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can
+        run.  These include that the program is being run by the root
+        user, and that this command is called with appropriate
+        arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkRootUID(base)
+        if basecmd == 'autoremove':
+            return
         checkPackageArg(base, basecmd, extcmds)
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
+
+        pos = False
+        if basecmd.startswith('autoremove'):
+            #  We have to alter this, as it's used in resolving stage. Which
+            # sucks. Just be careful in "yum shell".
+            base.conf.clean_requirements_on_remove = True
+
+            basecmd = basecmd[len('auto'):] # pretend it's just remove...
+
+            if not extcmds:
+                pos = True
+                extcmds = []
+                for pkg in sorted(base.rpmdb.returnLeafNodes()):
+                    if 'reason' not in pkg.yumdb_info:
+                        continue
+                    if pkg.yumdb_info.reason != 'dep':
+                        continue
+                    extcmds.append(pkg)
+
         self.doneCommand(base, _("Setting up Remove Process"))
-        try:
-            return base.erasePkgs(extcmds)
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+        ret = base.erasePkgs(extcmds, pos=pos, basecmd=basecmd)
+
+        return ret
 
     def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before this
+        command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
         return False
 
     def needTsRemove(self, base, basecmd, extcmds):
+        """Return whether a transaction set for removal only must be
+        set up before this command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a remove-only transaction set is needed, False otherwise
+        """
         return True
 
+
+class AutoremoveCommand(EraseCommand):
+    """A class containing methods needed by the cli to execute the
+    autremove command.
+    """
+    def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
+        return [ 'autoremove', 'autoremove-n', 'autoremove-na', 'autoremove-nevra']
+
+    def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
+        return _("Remove leaf packages")
+
  
 class GroupsCommand(YumCommand):
     """ Single sub-command interface for most groups interaction. """
 
     direct_commands = {'grouplist'    : 'list',
                        'groupinstall' : 'install',
-                       'groupupdate'  : 'install',
+                       'groupupdate'  : 'update',
                        'groupremove'  : 'remove',
                        'grouperase'   : 'remove',
                        'groupinfo'    : 'info'}
 
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['groups', 'group'] + self.direct_commands.keys()
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return "[list|info|summary|install|upgrade|remove|mark] [GROUP]"
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Display, or use, the groups information")
     
     def _grp_setup_doCommand(self, base):
@@ -459,7 +945,7 @@ class GroupsCommand(YumCommand):
         except yum.Errors.GroupsError:
             return 1, [_('No Groups on which to run command')]
         except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+            raise
 
     def _grp_cmd(self, basecmd, extcmds):
         if basecmd in self.direct_commands:
@@ -470,6 +956,10 @@ class GroupsCommand(YumCommand):
         else:
             cmd = 'summary'
 
+        if cmd in ('mark', 'unmark') and extcmds:
+            cmd = "%s-%s" % (cmd, extcmds[0])
+            extcmds = extcmds[1:]
+
         remap = {'update' : 'upgrade',
                  'erase' : 'remove',
                  'mark-erase' : 'mark-remove',
@@ -479,32 +969,86 @@ class GroupsCommand(YumCommand):
         return cmd, extcmds
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can run.
+        The exact conditions checked will vary depending on the
+        subcommand that is being called.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         cmd, extcmds = self._grp_cmd(basecmd, extcmds)
 
         checkEnabledRepo(base)
-
-        if cmd in ('install', 'remove',
-                   'mark-install', 'mark-remove',
-                   'mark-members', 'info', 'mark-members-sync'):
+        ocmds_all = []
+        ocmds_arg = []
+        if base.conf.group_command == 'objects':
+            ocmds_arg = ('mark-install', 'mark-remove',
+                         'mark-blacklist',
+                         'mark-packages', 'mark-packages-force',
+                         'unmark-packages',
+                         'mark-packages-sync', 'mark-packages-sync-force',
+                         'mark-groups', 'mark-groups-force',
+                         'unmark-groups',
+                         'mark-groups-sync', 'mark-groups-sync-force')
+
+            ocmds_all = ('mark-install', 'mark-remove', 'mark-convert',
+                         'mark-convert-whitelist', 'mark-convert-blacklist',
+                         'mark-blacklist',
+                         'mark-packages', 'mark-packages-force',
+                         'unmark-packages',
+                         'mark-packages-sync', 'mark-packages-sync-force',
+                         'mark-groups', 'mark-groups-force',
+                         'unmark-groups',
+                         'mark-groups-sync', 'mark-groups-sync-force')
+
+        if cmd in ('install', 'remove', 'info') or cmd in ocmds_arg:
             checkGroupArg(base, cmd, extcmds)
 
-        if cmd in ('install', 'remove', 'upgrade',
-                   'mark-install', 'mark-remove',
-                   'mark-members', 'mark-members-sync'):
+        if cmd in ('install', 'remove', 'upgrade') or cmd in ocmds_all:
             checkRootUID(base)
 
         if cmd in ('install', 'upgrade'):
             checkGPGKey(base)
 
-        cmds = ('list', 'info', 'remove', 'install', 'upgrade', 'summary',
-                'mark-install', 'mark-remove',
-                'mark-members', 'mark-members-sync')
+        cmds = set(('list', 'info', 'remove', 'install', 'upgrade', 'summary'))
+        if base.conf.group_command == 'objects':
+            cmds.update(ocmds_all)
+
         if cmd not in cmds:
             base.logger.critical(_('Invalid groups sub-command, use: %s.'),
                                  ", ".join(cmds))
             raise cli.CliError
 
+        if base.conf.group_command != 'objects':
+            pass
+        elif not os.path.exists(os.path.dirname(base.igroups.filename)):
+            base.logger.critical(_("There is no installed groups file."))
+            base.logger.critical(_("Maybe run: yum groups mark convert (see man yum)"))
+        elif not os.access(os.path.dirname(base.igroups.filename), os.R_OK):
+            base.logger.critical(_("You don't have access to the groups DBs."))
+            raise cli.CliError
+        elif not os.path.exists(base.igroups.filename):
+            base.logger.critical(_("There is no installed groups file."))
+            base.logger.critical(_("Maybe run: yum groups mark convert (see man yum)"))
+        elif not os.access(base.igroups.filename, os.R_OK):
+            base.logger.critical(_("You don't have access to the groups DB."))
+            raise cli.CliError
+
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         cmd, extcmds = self._grp_cmd(basecmd, extcmds)
 
         self._grp_setup_doCommand(base)
